------------------------------------------------------------------------------
--                                                                          --
--                         GNAT COMPILER COMPONENTS                         --
--                                                                          --
--      S Y S T E M . R P C . P A R T I T I O N _ I N T E R F A C E         --
--                                                                          --
--                                 Body                                     --
--                                                                          --
--                            $Revision: 1.3 $                              --
--                                                                          --
--        Copyright (C) 1992,1993,1994 Free Software Foundation, Inc.       --
--                                                                          --
-- GNAT is free software;  you can  redistribute it  and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion.  GNAT is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License  distributed with GNAT;  see file COPYING.  If not, write --
-- to  the Free Software Foundation,  59 Temple Place - Suite 330,  Boston, --
-- MA 02111-1307, USA.                                                      --
--                                                                          --
-- GNAT was originally developed  by the GNAT team at  New York University. --
-- It is now maintained by Ada Core Technologies Inc (http://www.gnat.com). --
--                                                                          --
------------------------------------------------------------------------------


package body System.RPC.Partition_Interface is


   function Getpid return Integer;
   pragma Import (C, Getpid);

   function Get_Local_Partition_ID return Partition_ID is
   begin
      return Partition_ID (Getpid mod 7);
   end Get_Local_Partition_ID;

   function Get_Active_Partition_ID (Name : in Library_Unit_Name)
     return Partition_ID is
   begin
      return Partition_ID'First;
   end Get_Active_Partition_ID;

   function Get_Passive_Partition_ID (Name : in Library_Unit_Name)
     return Partition_ID is
   begin
      return Partition_ID (Getpid mod 7);
   end Get_Passive_Partition_ID;

   procedure Register_Server_Elaboration
     (Name     : in Library_Unit_Name;
      Receiver : in RPC_Receiver) is
   begin
      null;
   end Register_Server_Elaboration;

   function Get_RCI_Package_Receiver (Name : in Library_Unit_Name)
     return RPC_Receiver is
      x : RPC_Receiver;
   begin
      return x;
   end Get_RCI_Package_Receiver;

end System.RPC.Partition_Interface;
