
------------------------------------------------------------
--        Name: Alden Dima
--      E-mail: dimaaa@seas.gwu.edu
--      School: The George Washington University
--              School of Engineering and Applied Science
--              Washington, D.C.
--       Class: CSci 298 - Independent Study
--     Project: Ada Curses Binding and Textual User Interface
--        File: adcolbox.adb "adatui-color_box.adb"
--        Date: 12/24/95 
-- Description: One of many adatui subunit bodies, this file
--              implements a subprogram declared in the adatui
--              package.
------------------------------------------------------------

separate (AdaTUI)
procedure color_box (  
   window : curses.A_WINDOW_T;
   color  : integer;
   hasbox : boolean )
is  
   attr : curses.chtype;
   parm : curses.chtype;
   void : c.signed_int;
   subtype ch is curses.chtype;
   use type ch;

begin
   attr := ch(color) and ch(A_ATTR);

   set_color (
      window => window,
      color  => color );

   if curses.has_colors /= curses.FALSE then
      parm := curses.macros.color_pair( ch(color) and ch(curses.A_CHARTEXT) );
      parm := parm or ( attr and not ch(curses.A_REVERSE) );
      void := curses.wbkgd ( window, parm );
   else
      void := curses.wbkgd ( window, ch(color) );
   end if;

   void := curses.werase ( window );

   if hasbox and (window.maxy > 2) then
      void := curses.macros.box ( window, 0, 0 );
   end if;

   void := curses.touchwin ( window );
   void := curses.wrefresh ( window );
end color_box;
