
------------------------------------------------------------
--        Name: Alden Dima
--      E-mail: dimaaa@seas.gwu.edu
--      School: The George Washington University
--              School of Engineering and Applied Science
--              Washington, D.C.
--       Class: CSci 298 - Independent Study
--     Project: Ada Curses Binding and Textual User Interface
--        File: admendim.adb "adatui-menu_dimension.adb"
--        Date: 12/24/95 
-- Description: One of many adatui subunit bodies, this file
--              implements a subprogram declared in the adatui
--              package.
------------------------------------------------------------

separate (AdaTUI)
procedure menu_dimension (
   a_menu  : a_menu_t;
   lines   : access integer;
   cols    : access integer )
is
   length : integer; 
   max    : integer := 0;

begin
   for index in a_menu.all'range loop
      length := a_menu.all(index).item_name.all'length;
      if length > max then
	 max := length;
      end if;
   end loop;

   lines.all := a_menu.all'length;
   cols.all  := max + 2;
end menu_dimension;
