
------------------------------------------------------------
--        Name: Alden Dima
--      E-mail: dimaaa@seas.gwu.edu
--      School: The George Washington University
--              School of Engineering and Applied Science
--              Washington, D.C.
--       Class: CSci 298 - Independent Study
--     Project: Ada Curses Binding and Textual User Interface
--        File: adstamen.adb "adatui-start_menu.adb"
--        Date: 12/24/95 
-- Description: One of many adatui subunit bodies, this file
--              implements a subprogram declared in the adatui
--              package.
------------------------------------------------------------

separate (AdaTUI)
procedure start_menu ( 
   mp    : a_menu_t;
   title : string )
is
   void : c.signed_int;

begin
   screen_window := curses.initscr;
   in_curses := TRUE;
   init_color;
   title_window  := curses.subwin ( screen_window, th, bw,            0, 0 );
   main_window   := curses.subwin ( screen_window, mh, bw,           th, 0 );
   body_window   := curses.subwin ( screen_window, bh, bw,      th + mh, 0 );
   status_window := curses.subwin ( screen_window, sh, bw, th + mh + bh, 0 );

   color_box (  
      window => title_window,
      color  => TITLECOLOR,
      hasbox => FALSE ); 

   color_box (  
      window => main_window,
      color  => MAINMENUCOLOR,
      hasbox => FALSE ); 

   color_box (  
      window => body_window,
      color  => BODYCOLOR,
      hasbox => FALSE ); 

   color_box (  
      window => status_window,
      color  => STATUSCOLOR,
      hasbox => FALSE ); 

   if title'length > 0 then
      title_message ( msg => title );
   end if;

   curses.macros.cbreak;
   curses.macros.noecho;
   hide_cursor;
   curses.macros.nodelay  ( body_window, curses.TRUE );
   curses.macros.keypad   ( body_window, curses.TRUE );
   curses.macros.scrollok ( body_window, curses.TRUE );
   curses.macros.leaveok  ( screen_window, curses.TRUE );
   curses.macros.leaveok  ( title_window, curses.TRUE );
   curses.macros.leaveok  ( main_window, curses.TRUE );
   curses.macros.leaveok  ( status_window, curses.TRUE );
   main_menu ( mp => mp );
   clean_up;
end start_menu;
