
------------------------------------------------------------
--        Name: Alden Dima
--      E-mail: dimaaa@seas.gwu.edu
--      School: The George Washington University
--              School of Engineering and Applied Science
--              Washington, D.C.
--       Class: CSci 298 - Independent Study
--     Project: Ada Curses Binding and Textual User Interface
--        File: curses.ads
--        Date: 12/24/95
-- Description: Package specification for curses binding
--              generated by cbind header file conversion
--              utility.
------------------------------------------------------------

with c;
with system;

package Curses is

    type bool is new c.unsigned_char;                           -- curses.h:426
    type chtype is new c.unsigned_int;                          -- curses.h:434

    PDCURSES            : constant := 1;                        -- curses.h:135
    XOPEN               : constant := 1;                        -- curses.h:136
    SYSV                : constant := 1;                        -- curses.h:137
    BSD                 : constant := 1;                        -- curses.h:138
    INTERNAL            : constant := 1;                        -- curses.h:139
    GO32                : constant := 1;                        -- curses.h:307
    ANSI                : constant := 1;                        -- curses.h:308
    DOS                 : constant := 6;                        -- curses.h:310
    NO_VSSCANF          : constant := 1;                        -- curses.h:319
    FALSE               : constant := 8#0000#;                  -- curses.h:403
    TRUE                : constant := 8#0001#;                  -- curses.h:406
    ERR                 : constant := 8#0000#;                  -- curses.h:412
    OK                  : constant := 1;                        -- curses.h:415
    A_NORMAL            : constant := 16#0000#;                 -- curses.h:641
    A_STANDOUT          : constant := 16#00A0_0000#;            -- curses.h:642
    A_BOLD              : constant := 16#0080_0000#;            -- curses.h:643
    A_UNDERLINE         : constant := 16#0010_0000#;            -- curses.h:644
    A_REVERSE           : constant := 16#0020_0000#;            -- curses.h:645
    A_BLINK             : constant := 16#0040_0000#;            -- curses.h:646
    A_DIM               : constant := 16#0002_0000#;            -- curses.h:647
    A_INVIS             : constant := 16#0008_0000#;            -- curses.h:648
    A_PROTECT           : constant := 16#0001_0000#;            -- curses.h:649
    A_ALTCHARSET        : constant := 16#0004_0000#;            -- curses.h:650
    A_ATTRIBUTES        : constant := 16#FFFF_0000#;            -- curses.h:651
    A_CHARTEXT          : constant := 16#0000_FFFF#;            -- curses.h:652
    A_COLOR             : constant := 16#FF00_0000#;            -- curses.h:653
    CHR_MSK             : constant := 16#0000_FFFF#;            -- curses.h:672
    ATR_MSK             : constant := 16#FFFF_0000#;            -- curses.h:673
    ATR_NRM             : constant := 16#0000#;                 -- curses.h:674
    ACS_ULCORNER        : constant chtype := 218;               -- curses.h:751
    ACS_LLCORNER        : constant chtype := 192;               -- curses.h:752
    ACS_URCORNER        : constant chtype := 191;               -- curses.h:753
    ACS_LRCORNER        : constant chtype := 217;               -- curses.h:754
    ACS_RTEE            : constant chtype := 180;               -- curses.h:755
    ACS_LTEE            : constant chtype := 195;               -- curses.h:756
    ACS_BTEE            : constant chtype := 193;               -- curses.h:757
    ACS_TTEE            : constant chtype := 194;               -- curses.h:758
    ACS_HLINE           : constant chtype := 196;               -- curses.h:759
    ACS_VLINE           : constant chtype := 179;               -- curses.h:760
    ACS_PLUS            : constant chtype := 197;               -- curses.h:761
    ACS_S1              : constant chtype := 45;                -- curses.h:762
    ACS_S9              : constant chtype := 95;                -- curses.h:763
    ACS_DIAMOND         : constant chtype := 197;               -- curses.h:764
    ACS_CKBOARD         : constant chtype := 178;               -- curses.h:765
    ACS_DEGREE          : constant chtype := 248;               -- curses.h:766
    ACS_PLMINUS         : constant chtype := 241;               -- curses.h:767
    ACS_BULLET          : constant chtype := 249;               -- curses.h:768
    ACS_LARROW          : constant chtype := 60;                -- curses.h:769
    ACS_RARROW          : constant chtype := 62;                -- curses.h:770
    ACS_DARROW          : constant chtype := 118;               -- curses.h:771
    ACS_UARROW          : constant chtype := 94;                -- curses.h:772
    ACS_BOARD           : constant chtype := 35;                -- curses.h:773
    ACS_LANTERN         : constant chtype := 35;                -- curses.h:774
    ACS_BLOCK           : constant chtype := 35;                -- curses.h:775
    COLOR_BLACK         : constant := 8#0000#;                  -- curses.h:802
    COLOR_BLUE          : constant := 1;                        -- curses.h:803
    COLOR_GREEN         : constant := 2;                        -- curses.h:804
    COLOR_CYAN          : constant := 3;                        -- curses.h:805
    COLOR_RED           : constant := 4;                        -- curses.h:806
    COLOR_MAGENTA       : constant := 5;                        -- curses.h:807
    COLOR_YELLOW        : constant := 6;                        -- curses.h:808
    COLOR_WHITE         : constant := 7;                        -- curses.h:809
    KEY_MIN             : constant := 16#0101#;                 -- curses.h:827
    KEY_BREAK           : constant := 16#0101#;                 -- curses.h:828
    KEY_DOWN            : constant := 16#0102#;                 -- curses.h:829
    KEY_UP              : constant := 16#0103#;                 -- curses.h:830
    KEY_LEFT            : constant := 16#0104#;                 -- curses.h:831
    KEY_RIGHT           : constant := 16#0105#;                 -- curses.h:832
    KEY_HOME            : constant := 16#0106#;                 -- curses.h:833
    KEY_BACKSPACE       : constant := 16#0107#;                 -- curses.h:834
    KEY_F0              : constant := 16#0108#;                 -- curses.h:835
    KEY_DL              : constant := 16#0148#;                 -- curses.h:837
    KEY_IL              : constant := 16#0149#;                 -- curses.h:838
    KEY_DC              : constant := 16#014A#;                 -- curses.h:839
    KEY_IC              : constant := 16#014B#;                 -- curses.h:840
    KEY_EIC             : constant := 16#014C#;                 -- curses.h:841
    KEY_CLEAR           : constant := 16#014D#;                 -- curses.h:842
    KEY_EOS             : constant := 16#014E#;                 -- curses.h:843
    KEY_EOL             : constant := 16#014F#;                 -- curses.h:844
    KEY_SF              : constant := 16#0150#;                 -- curses.h:845
    KEY_SR              : constant := 16#0151#;                 -- curses.h:846
    KEY_NPAGE           : constant := 16#0152#;                 -- curses.h:847
    KEY_PPAGE           : constant := 16#0153#;                 -- curses.h:848
    KEY_STAB            : constant := 16#0154#;                 -- curses.h:849
    KEY_CTAB            : constant := 16#0155#;                 -- curses.h:850
    KEY_CATAB           : constant := 16#0156#;                 -- curses.h:851
    KEY_ENTER           : constant := 16#0157#;                 -- curses.h:852
    KEY_SRESET          : constant := 16#0158#;                 -- curses.h:853
    KEY_RESET           : constant := 16#0159#;                 -- curses.h:854
    KEY_PRINT           : constant := 16#015A#;                 -- curses.h:855
    KEY_LL              : constant := 16#015B#;                 -- curses.h:856
    KEY_ABORT           : constant := 16#015C#;                 -- curses.h:857
    KEY_SHELP           : constant := 16#015D#;                 -- curses.h:858
    KEY_LHELP           : constant := 16#015E#;                 -- curses.h:859
    KEY_BTAB            : constant := 16#015F#;                 -- curses.h:860
    KEY_BEG             : constant := 16#0160#;                 -- curses.h:861
    KEY_CANCEL          : constant := 16#0161#;                 -- curses.h:862
    KEY_CLOSE           : constant := 16#0162#;                 -- curses.h:863
    KEY_COMMAND         : constant := 16#0163#;                 -- curses.h:864
    KEY_COPY            : constant := 16#0164#;                 -- curses.h:865
    KEY_CREATE          : constant := 16#0165#;                 -- curses.h:866
    KEY_END             : constant := 16#0166#;                 -- curses.h:867
    KEY_EXIT            : constant := 16#0167#;                 -- curses.h:868
    KEY_FIND            : constant := 16#0168#;                 -- curses.h:869
    KEY_HELP            : constant := 16#0169#;                 -- curses.h:870
    KEY_MARK            : constant := 16#016A#;                 -- curses.h:871
    KEY_MESSAGE         : constant := 16#016B#;                 -- curses.h:872
    KEY_MOVE            : constant := 16#016C#;                 -- curses.h:873
    KEY_NEXT            : constant := 16#016D#;                 -- curses.h:874
    KEY_OPEN            : constant := 16#016E#;                 -- curses.h:875
    KEY_OPTIONS         : constant := 16#016F#;                 -- curses.h:876
    KEY_PREVIOUS        : constant := 16#0170#;                 -- curses.h:877
    KEY_REDO            : constant := 16#0171#;                 -- curses.h:878
    KEY_REFERENCE       : constant := 16#0172#;                 -- curses.h:879
    KEY_REFRESH         : constant := 16#0173#;                 -- curses.h:880
    KEY_REPLACE         : constant := 16#0174#;                 -- curses.h:881
    KEY_RESTART         : constant := 16#0175#;                 -- curses.h:882
    KEY_RESUME          : constant := 16#0176#;                 -- curses.h:883
    KEY_SAVE            : constant := 16#0177#;                 -- curses.h:884
    KEY_SBEG            : constant := 16#0178#;                 -- curses.h:885
    KEY_SCANCEL         : constant := 16#0179#;                 -- curses.h:886
    KEY_SCOMMAND        : constant := 16#017A#;                 -- curses.h:887
    KEY_SCOPY           : constant := 16#017B#;                 -- curses.h:888
    KEY_SCREATE         : constant := 16#017C#;                 -- curses.h:889
    KEY_SDC             : constant := 16#017D#;                 -- curses.h:890
    KEY_SDL             : constant := 16#017E#;                 -- curses.h:891
    KEY_SELECT          : constant := 16#017F#;                 -- curses.h:892
    KEY_SEND            : constant := 16#0180#;                 -- curses.h:893
    KEY_SEOL            : constant := 16#0181#;                 -- curses.h:894
    KEY_SEXIT           : constant := 16#0182#;                 -- curses.h:895
    KEY_SFIND           : constant := 16#0183#;                 -- curses.h:896
    KEY_SHOME           : constant := 16#0184#;                 -- curses.h:897
    KEY_SIC             : constant := 16#0185#;                 -- curses.h:898
    KEY_SLEFT           : constant := 16#0187#;                 -- curses.h:899
    KEY_SMESSAGE        : constant := 16#0188#;                 -- curses.h:900
    KEY_SMOVE           : constant := 16#0189#;                 -- curses.h:901
    KEY_SNEXT           : constant := 16#018A#;                 -- curses.h:902
    KEY_SOPTIONS        : constant := 16#018B#;                 -- curses.h:903
    KEY_SPREVIOUS       : constant := 16#018C#;                 -- curses.h:904
    KEY_SPRINT          : constant := 16#018D#;                 -- curses.h:905
    KEY_SREDO           : constant := 16#018E#;                 -- curses.h:906
    KEY_SREPLACE        : constant := 16#018F#;                 -- curses.h:907
    KEY_SRIGHT          : constant := 16#0190#;                 -- curses.h:908
    KEY_SRSUME          : constant := 16#0191#;                 -- curses.h:909
    KEY_SSAVE           : constant := 16#0192#;                 -- curses.h:910
    KEY_SSUSPEND        : constant := 16#0193#;                 -- curses.h:911
    KEY_SUNDO           : constant := 16#0194#;                 -- curses.h:912
    KEY_SUSPEND         : constant := 16#0195#;                 -- curses.h:913
    KEY_UNDO            : constant := 16#0196#;                 -- curses.h:914
    ALT_0               : constant := 16#0197#;                 -- curses.h:918
    ALT_1               : constant := 16#0198#;                 -- curses.h:919
    ALT_2               : constant := 16#0199#;                 -- curses.h:920
    ALT_3               : constant := 16#019A#;                 -- curses.h:921
    ALT_4               : constant := 16#019B#;                 -- curses.h:922
    ALT_5               : constant := 16#019C#;                 -- curses.h:923
    ALT_6               : constant := 16#019D#;                 -- curses.h:924
    ALT_7               : constant := 16#019E#;                 -- curses.h:925
    ALT_8               : constant := 16#019F#;                 -- curses.h:926
    ALT_9               : constant := 16#01A0#;                 -- curses.h:927
    ALT_A               : constant := 16#01A1#;                 -- curses.h:928
    ALT_B               : constant := 16#01A2#;                 -- curses.h:929
    ALT_C               : constant := 16#01A3#;                 -- curses.h:930
    ALT_D               : constant := 16#01A4#;                 -- curses.h:931
    ALT_E               : constant := 16#01A5#;                 -- curses.h:932
    ALT_F               : constant := 16#01A6#;                 -- curses.h:933
    ALT_G               : constant := 16#01A7#;                 -- curses.h:934
    ALT_H               : constant := 16#01A8#;                 -- curses.h:935
    ALT_I               : constant := 16#01A9#;                 -- curses.h:936
    ALT_J               : constant := 16#01AA#;                 -- curses.h:937
    ALT_K               : constant := 16#01AB#;                 -- curses.h:938
    ALT_L               : constant := 16#01AC#;                 -- curses.h:939
    ALT_M               : constant := 16#01AD#;                 -- curses.h:940
    ALT_N               : constant := 16#01AE#;                 -- curses.h:941
    ALT_O               : constant := 16#01AF#;                 -- curses.h:942
    ALT_P               : constant := 16#01B0#;                 -- curses.h:943
    ALT_Q               : constant := 16#01B1#;                 -- curses.h:944
    ALT_R               : constant := 16#01B2#;                 -- curses.h:945
    ALT_S               : constant := 16#01B3#;                 -- curses.h:946
    ALT_T               : constant := 16#01B4#;                 -- curses.h:947
    ALT_U               : constant := 16#01B5#;                 -- curses.h:948
    ALT_V               : constant := 16#01B6#;                 -- curses.h:949
    ALT_W               : constant := 16#01B7#;                 -- curses.h:950
    ALT_X               : constant := 16#01B8#;                 -- curses.h:951
    ALT_Y               : constant := 16#01B9#;                 -- curses.h:952
    ALT_Z               : constant := 16#01BA#;                 -- curses.h:953
    CTL_LEFT            : constant := 16#01BB#;                 -- curses.h:954
    CTL_RIGHT           : constant := 16#01BC#;                 -- curses.h:955
    CTL_PGUP            : constant := 16#01BD#;                 -- curses.h:956
    CTL_PGDN            : constant := 16#01BE#;                 -- curses.h:957
    CTL_HOME            : constant := 16#01BF#;                 -- curses.h:958
    CTL_END             : constant := 16#01C0#;                 -- curses.h:959
    KEY_BACKTAB         : constant := 16#01C1#;                 -- curses.h:960
    KEY_A1              : constant := 16#01C2#;                 -- curses.h:978
    KEY_A2              : constant := 16#01C3#;                 -- curses.h:979
    KEY_A3              : constant := 16#01C4#;                 -- curses.h:980
    KEY_B1              : constant := 16#01C5#;                 -- curses.h:981
    KEY_B2              : constant := 16#01C6#;                 -- curses.h:982
    KEY_B3              : constant := 16#01C7#;                 -- curses.h:983
    KEY_C1              : constant := 16#01C8#;                 -- curses.h:984
    KEY_C2              : constant := 16#01C9#;                 -- curses.h:985
    KEY_C3              : constant := 16#01CA#;                 -- curses.h:986
    PADSLASH            : constant := 16#01CB#;                 -- curses.h:987
    PADENTER            : constant := 16#01CC#;                 -- curses.h:988
    CTL_PADENTER        : constant := 16#01CD#;                 -- curses.h:989
    ALT_PADENTER        : constant := 16#01CE#;                 -- curses.h:990
    SHF_PADSTOP         : constant := 16#01CF#;                 -- curses.h:991
    PADSTAR             : constant := 16#01D0#;                 -- curses.h:992
    PADMINUS            : constant := 16#01D1#;                 -- curses.h:993
    PADPLUS             : constant := 16#01D2#;                 -- curses.h:994
    CTL_PADSTOP         : constant := 16#01D3#;                 -- curses.h:995
    CTL_PADCENTER       : constant := 16#01D4#;                 -- curses.h:996
    CTL_PADPLUS         : constant := 16#01D5#;                 -- curses.h:997
    CTL_PADMINUS        : constant := 16#01D6#;                 -- curses.h:998
    CTL_PADSLASH        : constant := 16#01D7#;                 -- curses.h:999
    CTL_PADSTAR         : constant := 16#01D8#;                 -- curses.h:1000
    ALT_PADPLUS         : constant := 16#01D9#;                 -- curses.h:1001
    ALT_PADMINUS        : constant := 16#01DA#;                 -- curses.h:1002
    ALT_PADSLASH        : constant := 16#01DB#;                 -- curses.h:1003
    ALT_PADSTAR         : constant := 16#01DC#;                 -- curses.h:1004
    CTL_INS             : constant := 16#01DD#;                 -- curses.h:1005
    ALT_DEL             : constant := 16#01DE#;                 -- curses.h:1006
    ALT_INS             : constant := 16#01DF#;                 -- curses.h:1007
    CTL_UP              : constant := 16#01E0#;                 -- curses.h:1008
    CTL_DOWN            : constant := 16#01E1#;                 -- curses.h:1009
    CTL_TAB             : constant := 16#01E2#;                 -- curses.h:1010
    ALT_TAB             : constant := 16#01E3#;                 -- curses.h:1011
    ALT_MINUS           : constant := 16#01E4#;                 -- curses.h:1012
    ALT_EQUAL           : constant := 16#01E5#;                 -- curses.h:1013
    ALT_HOME            : constant := 16#01E6#;                 -- curses.h:1014
    ALT_PGUP            : constant := 16#01E7#;                 -- curses.h:1015
    ALT_PGDN            : constant := 16#01E8#;                 -- curses.h:1016
    ALT_END             : constant := 16#01E9#;                 -- curses.h:1017
    ALT_UP              : constant := 16#01EA#;                 -- curses.h:1018
    ALT_DOWN            : constant := 16#01EB#;                 -- curses.h:1019
    ALT_RIGHT           : constant := 16#01EC#;                 -- curses.h:1020
    ALT_LEFT            : constant := 16#01ED#;                 -- curses.h:1021
    ALT_ENTER           : constant := 16#01EE#;                 -- curses.h:1022
    ALT_ESC             : constant := 16#01EF#;                 -- curses.h:1023
    ALT_BQUOTE          : constant := 16#01F0#;                 -- curses.h:1024
    ALT_LBRACKET        : constant := 16#01F1#;                 -- curses.h:1025
    ALT_RBRACKET        : constant := 16#01F2#;                 -- curses.h:1026
    ALT_SEMICOLON       : constant := 16#01F3#;                 -- curses.h:1027
    ALT_FQUOTE          : constant := 16#01F4#;                 -- curses.h:1028
    ALT_COMMA           : constant := 16#01F5#;                 -- curses.h:1029
    ALT_STOP            : constant := 16#01F6#;                 -- curses.h:1030
    ALT_FSLASH          : constant := 16#01F7#;                 -- curses.h:1031
    ALT_BKSP            : constant := 16#01F8#;                 -- curses.h:1032
    CTL_BKSP            : constant := 16#01F9#;                 -- curses.h:1033
    CTL_PAD0            : constant := 16#01FA#;                 -- curses.h:1034
    CTL_PAD1            : constant := 16#01FB#;                 -- curses.h:1035
    CTL_PAD2            : constant := 16#01FC#;                 -- curses.h:1036
    CTL_PAD3            : constant := 16#01FD#;                 -- curses.h:1037
    CTL_PAD4            : constant := 16#01FE#;                 -- curses.h:1038
    CTL_PAD5            : constant := 16#01FF#;                 -- curses.h:1039
    CTL_PAD6            : constant := 16#0200#;                 -- curses.h:1040
    CTL_PAD7            : constant := 16#0201#;                 -- curses.h:1041
    CTL_PAD8            : constant := 16#0202#;                 -- curses.h:1042
    CTL_PAD9            : constant := 16#0203#;                 -- curses.h:1043
    CTL_DEL             : constant := 16#0204#;                 -- curses.h:1044
    ALT_BSLASH          : constant := 16#0205#;                 -- curses.h:1045
    CTL_ENTER           : constant := 16#0206#;                 -- curses.h:1046
    KEY_MOUSE           : constant := 16#0207#;                 -- curses.h:1047
    KEY_MAX             : constant := 16#0207#;                 -- curses.h:1048
    FAST_VIDEO          : constant := 1;                        -- curspriv.h:109
    EMALLOC             : constant := 8#0000#;                  -- curspriv.h:179
    EMALLOC_MAGIC       : constant := 16#0C0C#;                 -- curspriv.h:180
    SUBWIN_C0           : constant := 16#0001#;                 -- curspriv.h:188
    ENDLINE             : constant := 16#0002#;                 -- curspriv.h:189
    FULLWIN             : constant := 16#0004#;                 -- curspriv.h:190
    SCROLLWIN           : constant := 16#0008#;                 -- curspriv.h:191
    PAD                 : constant := 16#0010#;                 -- curspriv.h:192
    SUBPAD_C0           : constant := 16#0020#;                 -- curspriv.h:193
    INBUFSIZ            : constant := 16#0200#;                 -- curspriv.h:200
    NO_CHANGE           : constant := -1;                       -- curspriv.h:201
    BCHAR               : constant := 16#0003#;                 -- curspriv.h:207
    ECHAR               : constant := 16#0008#;                 -- curspriv.h:208
    DWCHAR              : constant := 16#0017#;                 -- curspriv.h:209
    DLCHAR              : constant := 16#0015#;                 -- curspriv.h:210
    GOCHAR              : constant := 16#0011#;                 -- curspriv.h:211
    PRINTCHAR           : constant := 16#0010#;                 -- curspriv.h:212
    STOPCHAR            : constant := 16#0013#;                 -- curspriv.h:213
    NUNGETCH            : constant := 20;                       -- curspriv.h:214
    NONE                : constant := 16#0000#;                 -- curspriv.h:244
    MDA                 : constant := 16#0001#;                 -- curspriv.h:245
    CGA                 : constant := 16#0002#;                 -- curspriv.h:246
    EGACOLOR            : constant := 16#0004#;                 -- curspriv.h:247
    EGAMONO             : constant := 16#0005#;                 -- curspriv.h:248
    VGACOLOR            : constant := 16#0007#;                 -- curspriv.h:249
    VGAMONO             : constant := 16#0008#;                 -- curspriv.h:250
    MCGACOLOR           : constant := 16#000A#;                 -- curspriv.h:251
    MCGAMONO            : constant := 16#000B#;                 -- curspriv.h:252
    FLEXOS              : constant := 16#0020#;                 -- curspriv.h:253
    MDS_GENIUS          : constant := 16#0030#;                 -- curspriv.h:254
    UNIX_COLOR          : constant := 16#0040#;                 -- curspriv.h:255
    UNIX_MONO           : constant := 16#0041#;                 -- curspriv.h:256
    FONT8               : constant := 8;                        -- curspriv.h:259
    FONT14              : constant := 14;                       -- curspriv.h:260
    FONT15              : constant := 15;                       -- curspriv.h:261
    FONT16              : constant := 16#0010#;                 -- curspriv.h:262
    PDC_COLOR_PAIRS     : constant := 16#0040#;                 -- curspriv.h:371
    PDC_OFFSET          : constant := 16#0020#;                 -- curspriv.h:372
    MAX_ATRTAB          : constant := 2080;                     -- curspriv.h:373

    type a_c_signed_char_t is access all c.unsigned_char;       -- pc.h:34
    type a_chtype_t is access all chtype;                       -- curses.h:475
    type a_a_chtype_t is access all a_chtype_t;                 -- curses.h:475
    type vector_of_c_signed_char_t_c0 is                        -- curspriv.h:232
        array(integer range <>)
        of c.signed_char;

    type struct_anonymous0_t;                                   -- dos.h:16
    type struct_anonymous1_t;                                   -- dos.h:30
    type UNION_REGS;                                            -- dos.h:6
    type STRUCT_SREGS;                                          -- dos.h:33
    type struct_ftime;                                          -- dos.h:42
    type struct_date;                                           -- dos.h:51
    type struct_time;                                           -- dos.h:57
    type struct_dfree;                                          -- dos.h:64
    type struct_win;                                            -- curses.h:485
    type struct_anonymous3_t;                                   -- curses.h:586
    type struct_cttyset;                                        -- curspriv.h:220

    type A_UNION_REGS_T is access all UNION_REGS;               -- dos.h:77
    type A_STRUCT_SREGS_T is access all STRUCT_SREGS;           -- dos.h:78
    type a_struct_ftime_t is access all struct_ftime;           -- dos.h:85
    type a_struct_date_t is access all struct_date;             -- dos.h:91
    type a_struct_time_t is access all struct_time;             -- dos.h:92
    type a_struct_dfree_t is access all struct_dfree;           -- dos.h:96
    type a_struct_win_t is access all struct_win;               -- curses.h:485
    type A_WINDOW_T is access all struct_win;                   -- curses.h:595
    type A_SCREEN_T is access all struct_anonymous3_t;          -- curses.h:1110

    type struct_anonymous0_t is                                 -- dos.h:16
        record
            ax   : c.unsigned_int;                              -- dos.h:8
            bx   : c.unsigned_int;                              -- dos.h:9
            cx   : c.unsigned_int;                              -- dos.h:10
            dx   : c.unsigned_int;                              -- dos.h:11
            si   : c.unsigned_int;                              -- dos.h:12
            di   : c.unsigned_int;                              -- dos.h:13
            cflag: c.unsigned_int;                              -- dos.h:14
            flags: c.unsigned_int;                              -- dos.h:15
        end record;

    pragma Convention(C,  struct_anonymous0_t);                 -- dos.h:16

    type struct_anonymous1_t is                                 -- dos.h:30
        record
            al      : c.unsigned_char;                          -- dos.h:18
            ah      : c.unsigned_char;                          -- dos.h:19
            upper_ax: c.unsigned_short;                         -- dos.h:20
            bl      : c.unsigned_char;                          -- dos.h:21
            bh      : c.unsigned_char;                          -- dos.h:22
            upper_bx: c.unsigned_short;                         -- dos.h:23
            cl      : c.unsigned_char;                          -- dos.h:24
            ch      : c.unsigned_char;                          -- dos.h:25
            upper_cx: c.unsigned_short;                         -- dos.h:26
            dl      : c.unsigned_char;                          -- dos.h:27
            dh      : c.unsigned_char;                          -- dos.h:28
            upper_dx: c.unsigned_short;                         -- dos.h:29
        end record;

    pragma Convention(C,  struct_anonymous1_t);                 -- dos.h:30

    type UNION_REGS_kind is (                                   -- dos.h:6
        x_kind,
        h_kind
    );

    type UNION_REGS (Which: UNION_REGS_kind := x_kind) is       -- dos.h:6
        record
            case Which is
                when x_kind =>
                    x: struct_anonymous0_t;                     -- dos.h:16
                when h_kind =>
                    h: struct_anonymous1_t;                     -- dos.h:30
            end case;
        end record;

    pragma Convention(C, UNION_REGS);
 -- pragma Unchecked_Union(UNION_REGS);

    type STRUCT_SREGS is                                        -- dos.h:33
        record
            cs: c.unsigned_short;                               -- dos.h:34
            ds: c.unsigned_short;                               -- dos.h:35
            es: c.unsigned_short;                               -- dos.h:36
            fs: c.unsigned_short;                               -- dos.h:37
            gs: c.unsigned_short;                               -- dos.h:38
            ss: c.unsigned_short;                               -- dos.h:39
        end record;

    pragma Convention(C,  STRUCT_SREGS);                        -- dos.h:33

    type struct_ftime is                                        -- dos.h:42
        record
            ft_tsec : c.bits5;                                  -- dos.h:43
            ft_min  : c.bits6;                                  -- dos.h:44
            ft_hour : c.bits5;                                  -- dos.h:45
            ft_day  : c.bits5;                                  -- dos.h:46
            ft_month: c.bits4;                                  -- dos.h:47
            ft_year : c.bits7;                                  -- dos.h:48
        end record;

    for struct_ftime use                                        -- dos.h:42
        record at mod 4;
            ft_tsec  at 0 range 0 .. 4;                         -- dos.h:43
            ft_min   at 0 range 5 .. 10;                        -- dos.h:44
            ft_hour  at 0 range 11 .. 15;                       -- dos.h:45
            ft_day   at 0 range 16#0010# .. 20;                 -- dos.h:46
            ft_month at 0 range 21 .. 24;                       -- dos.h:47
            ft_year  at 0 range 25 .. 31;                       -- dos.h:48
        end record;

    type struct_date is                                         -- dos.h:51
        record
            da_year: c.signed_short;                            -- dos.h:52
            da_day : c.signed_char;                             -- dos.h:53
            da_mon : c.signed_char;                             -- dos.h:54
        end record;

    pragma Convention(C,  struct_date);                         -- dos.h:51

    type struct_time is                                         -- dos.h:57
        record
            ti_min : c.unsigned_char;                           -- dos.h:58
            ti_hour: c.unsigned_char;                           -- dos.h:59
            ti_hund: c.unsigned_char;                           -- dos.h:60
            ti_sec : c.unsigned_char;                           -- dos.h:61
        end record;

    pragma Convention(C,  struct_time);                         -- dos.h:57

    type struct_dfree is                                        -- dos.h:64
        record
            df_avail: c.unsigned_int;                           -- dos.h:65
            df_total: c.unsigned_int;                           -- dos.h:66
            df_bsec : c.unsigned_int;                           -- dos.h:67
            df_sclus: c.unsigned_int;                           -- dos.h:68
        end record;

    pragma Convention(C,  struct_dfree);                        -- dos.h:64

    type struct_win is                                          -- curses.h:485
        record
            cury      : c.signed_int;                           -- curses.h:449
            curx      : c.signed_int;                           -- curses.h:450
            maxy      : c.signed_int;                           -- curses.h:451
            maxx      : c.signed_int;                           -- curses.h:452
            pmaxy     : c.signed_int;                           -- curses.h:453
            pmaxx     : c.signed_int;                           -- curses.h:454
            begy      : c.signed_int;                           -- curses.h:455
            begx      : c.signed_int;                           -- curses.h:456
            lastpy    : c.signed_int;                           -- curses.h:457
            lastpx    : c.signed_int;                           -- curses.h:458
            lastsy1   : c.signed_int;                           -- curses.h:459
            lastsx1   : c.signed_int;                           -- curses.h:460
            lastsy2   : c.signed_int;                           -- curses.h:461
            lastsx2   : c.signed_int;                           -- curses.h:462
            flags     : c.signed_int;                           -- curses.h:463
            attrs     : chtype;                                 -- curses.h:464
            bkgd      : chtype;                                 -- curses.h:465
            tabsize   : c.signed_int;                           -- curses.h:466
            clear     : bool;                                   -- curses.h:467
            leave     : bool;                                   -- curses.h:468
            scroll    : bool;                                   -- curses.h:469
            nodelay   : bool;                                   -- curses.h:470
            immed     : bool;                                   -- curses.h:471
            use_keypad: bool;                                   -- curses.h:472
            use_idl   : bool;                                   -- curses.h:473
            use_idc   : bool;                                   -- curses.h:474
            y         : a_a_chtype_t;                           -- curses.h:475
            firstch   : c.a_signed_int_t;                       -- curses.h:476
            lastch    : c.a_signed_int_t;                       -- curses.h:477
            tmarg     : c.signed_int;                           -- curses.h:478
            bmarg     : c.signed_int;                           -- curses.h:479
            title     : c.charp;                                -- curses.h:480
            title_ofs : c.signed_char;                          -- curses.h:481
            title_attr: chtype;                                 -- curses.h:482
            blank     : chtype;                                 -- curses.h:483
            parx      : c.signed_int;                           -- curses.h:484
            pary      : c.signed_int;                           -- curses.h:484
            parent    : a_struct_win_t;                         -- curses.h:485
        end record;

    pragma Convention(C,  struct_win);                          -- curses.h:485

    subtype WINDOW is struct_win;                               -- curses.h:486

-- -----------------------------------------------------------------------------
    type struct_iobuf;                                          -- stdio.h:18

    type A_FILE_T is access all struct_iobuf;                   -- stdio.h:69

    type struct_iobuf is                                        -- stdio.h:18
        record
            cnt   : c.signed_int;                               -- stdio.h:19
            ptr   : c.charp;                                    -- stdio.h:20
            base  : c.charp;                                    -- stdio.h:21
            bufsiz: c.signed_int;                               -- stdio.h:22
            flag  : c.signed_short;                             -- stdio.h:23
            file  : c.signed_short;                             -- stdio.h:24
        end record;
-- -----------------------------------------------------------------------------

    type struct_anonymous3_t is                                 -- curses.h:586
        record
            alive         : bool;                               -- curses.h:521
            autocr        : bool;                               -- curses.h:522
            cbreak        : bool;                               -- curses.h:523
            echo          : bool;                               -- curses.h:524
            raw_inp       : bool;                               -- curses.h:525
            raw_out       : bool;                               -- curses.h:526
            refrbrk       : bool;                               -- curses.h:527
            orgcbr        : bool;                               -- curses.h:528
            visible_cursor: bool;                               -- curses.h:529
            audible       : bool;                               -- curses.h:530
            full_redraw   : bool;                               -- curses.h:531
            direct_video  : bool;                               -- curses.h:532
            mono          : bool;                               -- curses.h:533
            sizeable      : bool;                               -- curses.h:534
            bogus_adapter : bool;                               -- curses.h:535
            shell         : bool;                               -- curses.h:536
            blank         : chtype;                             -- curses.h:538
            orig_attr     : chtype;                             -- curses.h:539
            cursrow       : c.signed_int;                       -- curses.h:540
            curscol       : c.signed_int;                       -- curses.h:541
            cursor        : c.signed_int;                       -- curses.h:542
            visibility    : c.signed_int;                       -- curses.h:543
            video_page    : c.signed_int;                       -- curses.h:544
            orig_emulation: c.signed_int;                       -- curses.h:545
            orig_cursor   : c.signed_int;                       -- curses.h:546
            font          : c.signed_int;                       -- curses.h:547
            orig_font     : c.signed_int;                       -- curses.h:548
            lines         : c.signed_int;                       -- curses.h:549
            cols          : c.signed_int;                       -- curses.h:550
            emalloc       : c.signed_int;                       -- curses.h:551
            scrnmode      : c.signed_int;                       -- curses.h:567
            adapter       : c.signed_int;                       -- curses.h:568
            video_seg     : c.unsigned_int;                     -- curses.h:569
            video_ofs     : c.unsigned_int;                     -- curses.h:570
        end record;

    pragma Convention(C,  struct_anonymous3_t);                 -- curses.h:586

    subtype SCREEN is struct_anonymous3_t;                      -- curses.h:586

    subtype Regs_t is UNION_REGS;                               -- curspriv.h:113

    type struct_cttyset is                                      -- curspriv.h:220
        record
            been_set: bool;                                     -- curspriv.h:222
            saved   : SCREEN;                                   -- curspriv.h:223
        end record;

    pragma Convention(C,  struct_cttyset);                      -- curspriv.h:220

    ScreenAttrib   : c.unsigned_char;                           -- pc.h:51
    ScreenPrimary  : c.a_signed_short_t;                        -- pc.h:52
    ScreenSecondary: c.a_signed_short_t;                        -- pc.h:53

    LINES          : c.signed_int;                              -- curses.h:593
    COLS           : c.signed_int;                              -- curses.h:594
    stdscr         : A_WINDOW_T;                                -- curses.h:595
    cursvar        : SCREEN;                                    -- curses.h:596
    curscr         : A_WINDOW_T;                                -- curses.h:599
    default_lines  : c.signed_int;                              -- curses.h:600
    COLORS         : c.signed_int;                              -- curses.h:820
    COLOR_PAIRS    : c.signed_int;                              -- curses.h:820
    regs           : Regs_t;                                    -- curspriv.h:115
    c_sh_tty       : struct_cttyset;                            -- curspriv.h:226
    c_pr_tty       : struct_cttyset;                            -- curspriv.h:227
    c_save_tty     : struct_cttyset;                            -- curspriv.h:228
    c_save_trm     : struct_cttyset;                            -- curspriv.h:229
    c_printscanbuf : vector_of_c_signed_char_t_c0(0..c.max_bound);-- curspriv.h:232
    trace_on       : bool;                                      -- curspriv.h:235
    c_strbeg       : c.charp;                                   -- curspriv.h:238
    twin           : A_WINDOW_T;                                -- curspriv.h:241

    function inportb(port: c.unsigned_short) return c.unsigned_char;-- pc.h:31

    function inportw(port: c.unsigned_short) return c.unsigned_short;-- pc.h:32

    function inportl(port: c.unsigned_short) return c.unsigned_int;-- pc.h:33

    function inportsb(port: c.unsigned_short;
                      buf : a_c_signed_char_t;
                      len : c.unsigned_int)
                            return c.unsigned_char;             -- pc.h:34

    function inportsw(port: c.unsigned_short;
                      buf : c.a_unsigned_short_t;
                      len : c.unsigned_int)
                            return c.unsigned_short;            -- pc.h:35

    function inportsl(port: c.unsigned_short;
                      buf : c.a_unsigned_int_t;
                      len : c.unsigned_int)
                            return c.unsigned_int;              -- pc.h:36

    procedure outportb(port: c.unsigned_short;
                       data: c.unsigned_char);                  -- pc.h:37

    procedure outportw(port: c.unsigned_short;
                       data: c.unsigned_short);                 -- pc.h:38

    procedure outportl(port: c.unsigned_short;
                       data: c.unsigned_int);                   -- pc.h:39

    procedure outportsb(port: c.unsigned_short;
                        buf : a_c_signed_char_t;
                        len : c.unsigned_int);                  -- pc.h:40

    procedure outportsw(port: c.unsigned_short;
                        buf : c.a_unsigned_short_t;
                        len : c.unsigned_int);                  -- pc.h:41

    procedure outportsl(port: c.unsigned_short;
                        buf : c.a_unsigned_int_t;
                        len : c.unsigned_int);                  -- pc.h:42

    function kbhit return c.signed_int;                         -- pc.h:44

    function getkey return c.signed_int;                        -- pc.h:45

    function getxkey return c.signed_int;                       -- pc.h:46

    procedure sound(frequency: c.signed_int);                   -- pc.h:48

    function ScreenMode return c.signed_int;                    -- pc.h:56

    function ScreenRows return c.signed_int;                    -- pc.h:57

    function ScreenCols return c.signed_int;                    -- pc.h:58

    procedure ScreenPutChar(ch  : c.signed_int;
                            attr: c.signed_int;
                            x   : c.signed_int;
                            y   : c.signed_int);                -- pc.h:59

    procedure ScreenSetCursor(row: c.signed_int;
                              col: c.signed_int);               -- pc.h:60

    procedure ScreenGetCursor(row: c.a_signed_int_t;
                              col: c.a_signed_int_t);           -- pc.h:61

    procedure ScreenClear;                                      -- pc.h:62

    procedure ScreenUpdate(virtual_screen: system.address);     -- pc.h:63

    procedure ScreenUpdateLine(virtual_screen_line: system.address;
                               row                : c.signed_int);-- pc.h:64

    procedure ScreenRetrieve(virtual_screen: system.address);   -- pc.h:65

    function bdos(func: c.signed_int;
                  dx  : c.unsigned_int;
                  al  : c.unsigned_int)
                        return c.signed_int;                    -- dos.h:75

    function bdosptr(func: c.signed_int;
                     dx  : system.address;
                     al  : c.unsigned_int)
                           return c.signed_int;                 -- dos.h:76

    function int86(ivec : c.signed_int;
                   c_in : A_UNION_REGS_T;
                   c_out: A_UNION_REGS_T)
                          return c.signed_int;                  -- dos.h:77

    function int86x(ivec : c.signed_int;
                    c_in : A_UNION_REGS_T;
                    c_out: A_UNION_REGS_T;
                    seg  : A_STRUCT_SREGS_T)
                           return c.signed_int;                 -- dos.h:78

    function intdos(c_in : A_UNION_REGS_T;
                    c_out: A_UNION_REGS_T)
                           return c.signed_int;                 -- dos.h:79

    function intdosx(c_in : A_UNION_REGS_T;
                     c_out: A_UNION_REGS_T;
                     seg  : A_STRUCT_SREGS_T)
                            return c.signed_int;                -- dos.h:80

    function enable return c.signed_int;                        -- dos.h:82

    function disable return c.signed_int;                       -- dos.h:83

    function getftime(handle: c.signed_int;
                      ftimep: a_struct_ftime_t)
                              return c.signed_int;              -- dos.h:85

    function setftime(handle: c.signed_int;
                      ftimep: a_struct_ftime_t)
                              return c.signed_int;              -- dos.h:86

    function getcbrk return c.signed_int;                       -- dos.h:88

    function setcbrk(new_value: c.signed_int) return c.signed_int;-- dos.h:89

    procedure getdate(p1: a_struct_date_t);                     -- dos.h:91

    procedure gettime(p1: a_struct_time_t);                     -- dos.h:92

    procedure setdate(p1: a_struct_date_t);                     -- dos.h:93

    procedure settime(p1: a_struct_time_t);                     -- dos.h:94

    procedure getdfree(drive: c.unsigned_char;
                       ptr  : a_struct_dfree_t);                -- dos.h:96

    procedure c_delay(msec: c.unsigned_int);                    -- dos.h:98

    function get_default_drive return c.signed_int;             -- dos.h:99

    procedure fixpath(p1: c.charp;
                      p2: c.charp);                             -- dos.h:100

    function addchnstr(p1: a_chtype_t;
                       p2: c.signed_int)
                           return c.signed_int;                 -- curses.h:1060

    function baudrate return c.signed_int;                      -- curses.h:1061

    function beep return c.signed_int;                          -- curses.h:1062

    function border(p1: chtype;
                    p2: chtype;
                    p3: chtype;
                    p4: chtype;
                    p5: chtype;
                    p6: chtype;
                    p7: chtype;
                    p8: chtype)
                        return c.signed_int;                    -- curses.h:1063

    function breakchar return c.signed_char;                    -- curses.h:1064

    function can_change_color return c.signed_int;              -- curses.h:1065

    function clearok(p1: A_WINDOW_T;
                     p2: bool)
                         return c.signed_int;                   -- curses.h:1066

    function color_content(p1: c.signed_int;
                           p2: c.a_signed_short_t;
                           p3: c.a_signed_short_t;
                           p4: c.a_signed_short_t)
                               return c.signed_int;             -- curses.h:1067

    function copywin(p1: A_WINDOW_T;
                     p2: A_WINDOW_T;
                     p3: c.signed_int;
                     p4: c.signed_int;
                     p5: c.signed_int;
                     p6: c.signed_int;
                     p7: c.signed_int;
                     p8: c.signed_int;
                     p9: c.signed_int)
                         return c.signed_int;                   -- curses.h:1068

    function curs_set(p1: c.signed_int) return c.signed_int;    -- curses.h:1069

    function cursoff return c.signed_int;                       -- curses.h:1070

    function curson return c.signed_int;                        -- curses.h:1071

    function def_prog_mode return c.signed_int;                 -- curses.h:1072

    function def_shell_mode return c.signed_int;                -- curses.h:1073

    function delay_output(p1: c.signed_int) return c.signed_int;-- curses.h:1074

    function delwin(p1: A_WINDOW_T) return c.signed_int;        -- curses.h:1075

    function derwin(p1: A_WINDOW_T;
                    p2: c.signed_int;
                    p3: c.signed_int;
                    p4: c.signed_int;
                    p5: c.signed_int)
                        return A_WINDOW_T;                      -- curses.h:1076

    function doupdate return c.signed_int;                      -- curses.h:1077

    function dupwin(p1: A_WINDOW_T) return A_WINDOW_T;          -- curses.h:1078

    function endwin return c.signed_int;                        -- curses.h:1079

    function erasechar return c.signed_char;                    -- curses.h:1080

    function fixterm return c.signed_int;                       -- curses.h:1081

    function flash return c.signed_int;                         -- curses.h:1082

    function flushinp return c.signed_int;                      -- curses.h:1083

    function gettmode return c.signed_int;                      -- curses.h:1084

    function has_colors return bool;                            -- curses.h:1085

    function hline(p1: chtype;
                   p2: c.signed_int)
                       return c.signed_int;                     -- curses.h:1086

    function inchnstr(p1: a_chtype_t;
                      p2: c.signed_int)
                          return c.signed_int;                  -- curses.h:1087

    function init_color(p1: c.signed_short;
                        p2: c.signed_short;
                        p3: c.signed_short;
                        p4: c.signed_short)
                            return c.signed_int;                -- curses.h:1088

    function init_pair(p1: c.signed_short;
                       p2: c.signed_short;
                       p3: c.signed_short)
                           return c.signed_int;                 -- curses.h:1089

    function initscr return A_WINDOW_T;                         -- curses.h:1090

    function intrflush(p1: A_WINDOW_T;
                       p2: bool)
                           return c.signed_int;                 -- curses.h:1091

    function is_linetouched(p1: A_WINDOW_T;
                            p2: c.signed_int)
                                return c.signed_int;            -- curses.h:1092

    function is_wintouched(p1: A_WINDOW_T) return c.signed_int; -- curses.h:1093

    function keyname(p1: c.signed_int) return c.charp;          -- curses.h:1094

    function killchar return c.signed_char;                     -- curses.h:1095

    function longname return c.charp;                           -- curses.h:1096

    function meta(p1: A_WINDOW_T;
                  p2: bool)
                      return c.signed_int;                      -- curses.h:1097

    function mvaddrawch(p1: c.signed_int;
                        p2: c.signed_int;
                        p3: chtype)
                            return c.signed_int;                -- curses.h:1098

    function mvaddrawstr(p1: c.signed_int;
                         p2: c.signed_int;
                         p3: c.charp)
                             return c.signed_int;               -- curses.h:1099

    function mvcur(p1: c.signed_int;
                   p2: c.signed_int;
                   p3: c.signed_int;
                   p4: c.signed_int)
                       return c.signed_int;                     -- curses.h:1100

    function mvderwin(p1: A_WINDOW_T;
                      p2: c.signed_int;
                      p3: c.signed_int)
                          return c.signed_int;                  -- curses.h:1101

    function mvinsrawch(p1: c.signed_int;
                        p2: c.signed_int;
                        p3: chtype)
                            return c.signed_int;                -- curses.h:1102

    function mvprintw(p1: c.signed_int;
                      p2: c.signed_int;
                      p3: c.charp)
                          return c.signed_int;                  -- curses.h:1103

    function mvscanw(p1: c.signed_int;
                     p2: c.signed_int;
                     p3: c.charp)
                         return c.signed_int;                   -- curses.h:1104

    function mvwin(p1: A_WINDOW_T;
                   p2: c.signed_int;
                   p3: c.signed_int)
                       return c.signed_int;                     -- curses.h:1105

    function mvwinsrawch(p1: A_WINDOW_T;
                         p2: c.signed_int;
                         p3: c.signed_int;
                         p4: chtype)
                             return c.signed_int;               -- curses.h:1106

    function mvwprintw(p1: A_WINDOW_T;
                       p2: c.signed_int;
                       p3: c.signed_int;
                       p4: c.charp)
                           return c.signed_int;                 -- curses.h:1107

    function mvwscanw(p1: A_WINDOW_T;
                      p2: c.signed_int;
                      p3: c.signed_int;
                      p4: c.charp)
                          return c.signed_int;                  -- curses.h:1108

    function newpad(p1: c.signed_int;
                    p2: c.signed_int)
                        return A_WINDOW_T;                      -- curses.h:1109

    function newterm(p1: c.charp;
                     p2: A_FILE_T;      
                     p3: A_FILE_T)
                         return A_SCREEN_T;                     -- curses.h:1110

    function newwin(p1: c.signed_int;
                    p2: c.signed_int;
                    p3: c.signed_int;
                    p4: c.signed_int)
                        return A_WINDOW_T;                      -- curses.h:1111

    function noraw return c.signed_int;                         -- curses.h:1112

    function overlay(p1: A_WINDOW_T;
                     p2: A_WINDOW_T)
                         return c.signed_int;                   -- curses.h:1113

    function overwrite(p1: A_WINDOW_T;
                       p2: A_WINDOW_T)
                           return c.signed_int;                 -- curses.h:1114

    function pair_content(p1: c.signed_int;
                          p2: c.a_signed_short_t;
                          p3: c.a_signed_short_t)
                              return c.signed_int;              -- curses.h:1115

    function pnoutrefresh(p1: A_WINDOW_T;
                          p2: c.signed_int;
                          p3: c.signed_int;
                          p4: c.signed_int;
                          p5: c.signed_int;
                          p6: c.signed_int;
                          p7: c.signed_int)
                              return c.signed_int;              -- curses.h:1116

    function prefresh(p1: A_WINDOW_T;
                      p2: c.signed_int;
                      p3: c.signed_int;
                      p4: c.signed_int;
                      p5: c.signed_int;
                      p6: c.signed_int;
                      p7: c.signed_int)
                          return c.signed_int;                  -- curses.h:1117

    function printw(p1: c.charp) return c.signed_int;           -- curses.h:1118

    function raw return c.signed_int;                           -- curses.h:1119

    function refresh return c.signed_int;                       -- curses.h:1120

    function reset_prog_mode return c.signed_int;               -- curses.h:1121

    function reset_shell_mode return c.signed_int;              -- curses.h:1122

    function resetterm return c.signed_int;                     -- curses.h:1123

    function resetty return c.signed_int;                       -- curses.h:1124

    function saveoldterm return c.signed_int;                   -- curses.h:1125

    function saveterm return c.signed_int;                      -- curses.h:1126

    function savetty return c.signed_int;                       -- curses.h:1127

    function scanw(p1: c.charp) return c.signed_int;            -- curses.h:1128

    function scroll(p1: A_WINDOW_T) return c.signed_int;        -- curses.h:1129

    function set_term(p1: A_SCREEN_T) return A_SCREEN_T;        -- curses.h:1130

    function start_color return c.signed_int;                   -- curses.h:1131

    function subpad(p1: A_WINDOW_T;
                    p2: c.signed_int;
                    p3: c.signed_int;
                    p4: c.signed_int;
                    p5: c.signed_int)
                        return A_WINDOW_T;                      -- curses.h:1132

    function subwin(p1: A_WINDOW_T;
                    p2: c.signed_int;
                    p3: c.signed_int;
                    p4: c.signed_int;
                    p5: c.signed_int)
                        return A_WINDOW_T;                      -- curses.h:1133

    function tabsize(p1: c.signed_int) return c.signed_int;     -- curses.h:1134

    function termattrs return chtype;                           -- curses.h:1135

    function termname return c.charp;                           -- curses.h:1136

    function touchline(p1: A_WINDOW_T;
                       p2: c.signed_int;
                       p3: c.signed_int)
                           return c.signed_int;                 -- curses.h:1137

    function touchwin(p1: A_WINDOW_T) return c.signed_int;      -- curses.h:1138

    function typeahead(p1: c.signed_int) return c.signed_int;   -- curses.h:1139

    function unctrl(p1: chtype) return c.charp;                 -- curses.h:1140

    function vline(p1: chtype;
                   p2: c.signed_int)
                       return c.signed_int;                     -- curses.h:1141

    function waddchnstr(p1: A_WINDOW_T;
                        p2: a_chtype_t;
                        p3: c.signed_int)
                            return c.signed_int;                -- curses.h:1142

    function waddnstr(p1: A_WINDOW_T;
                      p2: c.charp;
                      p3: c.signed_int)
                          return c.signed_int;                  -- curses.h:1143

    function waddrawstr(p1: A_WINDOW_T;
                        p2: c.charp)
                            return c.signed_int;                -- curses.h:1144

    function waddstr(p1: A_WINDOW_T;
                     p2: c.charp)
                         return c.signed_int;                   -- curses.h:1145

    function wattroff(p1: A_WINDOW_T;
                      p2: chtype)
                          return c.signed_int;                  -- curses.h:1146

    function wattron(p1: A_WINDOW_T;
                     p2: chtype)
                         return c.signed_int;                   -- curses.h:1147

    function wattrset(p1: A_WINDOW_T;
                      p2: chtype)
                          return c.signed_int;                  -- curses.h:1148

    function wbkgd(p1: A_WINDOW_T;
                   p2: chtype)
                       return c.signed_int;                     -- curses.h:1149

    procedure wbkgdset(p1: A_WINDOW_T;
                       p2: chtype);                             -- curses.h:1150

    function wborder(p1: A_WINDOW_T;
                     p2: chtype;
                     p3: chtype;
                     p4: chtype;
                     p5: chtype;
                     p6: chtype;
                     p7: chtype;
                     p8: chtype;
                     p9: chtype)
                         return c.signed_int;                   -- curses.h:1151

    function wclear(p1: A_WINDOW_T) return c.signed_int;        -- curses.h:1152

    function wclrtobot(p1: A_WINDOW_T) return c.signed_int;     -- curses.h:1153

    function wclrtoeol(p1: A_WINDOW_T) return c.signed_int;     -- curses.h:1154

    function wdelch(p1: A_WINDOW_T) return c.signed_int;        -- curses.h:1155

    function wdeleteln(p1: A_WINDOW_T) return c.signed_int;     -- curses.h:1156

    function werase(p1: A_WINDOW_T) return c.signed_int;        -- curses.h:1157

    function wgetch(p1: A_WINDOW_T) return c.signed_int;        -- curses.h:1158

    function wgetnstr(p1: A_WINDOW_T;
                      p2: c.charp;
                      p3: c.signed_int)
                          return c.signed_int;                  -- curses.h:1159

    function wgetstr(p1: A_WINDOW_T;
                     p2: c.charp)
                         return c.signed_int;                   -- curses.h:1160

    function whline(p1: A_WINDOW_T;
                    p2: chtype;
                    p3: c.signed_int)
                        return c.signed_int;                    -- curses.h:1161

    function winchnstr(p1: A_WINDOW_T;
                       p2: a_chtype_t;
                       p3: c.signed_int)
                           return c.signed_int;                 -- curses.h:1162

    function winnstr(p1: A_WINDOW_T;
                     p2: c.charp;
                     p3: c.signed_int)
                         return c.signed_int;                   -- curses.h:1163

    function winsch(p1: A_WINDOW_T;
                    p2: chtype)
                        return c.signed_int;                    -- curses.h:1164

    function winsdelln(p1: A_WINDOW_T;
                       p2: c.signed_int)
                           return c.signed_int;                 -- curses.h:1165

    function winsertln(p1: A_WINDOW_T) return c.signed_int;     -- curses.h:1166

    function winsnstr(p1: A_WINDOW_T;
                      p2: c.charp;
                      p3: c.signed_int)
                          return c.signed_int;                  -- curses.h:1167

    function wmove(p1: A_WINDOW_T;
                   p2: c.signed_int;
                   p3: c.signed_int)
                       return c.signed_int;                     -- curses.h:1168

    function wnoutrefresh(p1: A_WINDOW_T) return c.signed_int;  -- curses.h:1169

    function wordchar return c.signed_char;                     -- curses.h:1170

    function wprintw(p1: A_WINDOW_T;
                     p2: c.charp)
                         return c.signed_int;                   -- curses.h:1171

    function wredrawln(p1: A_WINDOW_T;
                       p2: c.signed_int;
                       p3: c.signed_int)
                           return c.signed_int;                 -- curses.h:1172

    function wrefresh(p1: A_WINDOW_T) return c.signed_int;      -- curses.h:1173

    function wscanw(p1: A_WINDOW_T;
                    p2: c.charp)
                        return c.signed_int;                    -- curses.h:1174

    function wscrl(p1: A_WINDOW_T;
                   p2: c.signed_int)
                       return c.signed_int;                     -- curses.h:1175

    function wsetscrreg(p1: A_WINDOW_T;
                        p2: c.signed_int;
                        p3: c.signed_int)
                            return c.signed_int;                -- curses.h:1176

    function wtabsize(p1: A_WINDOW_T;
                      p2: c.signed_int)
                          return c.signed_int;                  -- curses.h:1177

    function wtouchln(p1: A_WINDOW_T;
                      p2: c.signed_int;
                      p3: c.signed_int;
                      p4: c.signed_int)
                          return c.signed_int;                  -- curses.h:1178

    function ungetch(p1: c.signed_int) return c.signed_int;     -- curses.h:1179

    function wvline(p1: A_WINDOW_T;
                    p2: chtype;
                    p3: c.signed_int)
                        return c.signed_int;                    -- curses.h:1180

    function raw_output(p1: bool) return c.signed_int;          -- curses.h:1183

    function resize_screen(p1: c.signed_int) return c.signed_int;-- curses.h:1184

    function resize_window(p1: A_WINDOW_T;
                           p2: c.signed_int;
                           p3: c.signed_int)
                               return A_WINDOW_T;               -- curses.h:1185

    function win_print(p1: A_WINDOW_T;
                       p2: c.signed_int)
                           return c.signed_int;                 -- curses.h:1186

    function PDC_CHADD(p1: A_WINDOW_T;
                       p2: chtype;
                       p3: bool;
                       p4: bool)
                           return c.signed_int;                 -- curses.h:1192

    function PDC_CHINS(p1: A_WINDOW_T;
                       p2: chtype;
                       p3: bool)
                           return c.signed_int;                 -- curses.h:1193

    function getdosmembyte(offs: c.signed_int) return c.unsigned_char;-- curspriv.h:135

    function getdosmemword(offs: c.signed_int) return c.unsigned_short;-- curspriv.h:136

    procedure setdosmembyte(offs: c.signed_int;
                            b   : c.unsigned_char);             -- curspriv.h:137

    procedure setdosmemword(offs: c.signed_int;
                            w   : c.unsigned_short);            -- curspriv.h:138

    function PDC_BACKCHAR(p1: A_WINDOW_T;
                          p2: c.charp;
                          p3: c.a_signed_int_t)
                              return c.signed_int;              -- curspriv.h:274

    function PDC_BREAKOUT return bool;                          -- curspriv.h:275

    function PDC_CHECK_BIOS_KEY return bool;                    -- curspriv.h:277

    function PDC_CHG_ATTR(p1: A_WINDOW_T;
                          p2: chtype;
                          p3: c.signed_int;
                          p4: c.signed_int;
                          p5: c.signed_int;
                          p6: c.signed_int)
                              return c.signed_int;              -- curspriv.h:278

    function PDC_CLR_SCRN(p1: A_WINDOW_T) return c.signed_int;  -- curspriv.h:280

    function PDC_CLR_UPDATE(p1: A_WINDOW_T) return c.signed_int;-- curspriv.h:281

    function PDC_COPY_WIN(p1 : A_WINDOW_T;
                          p2 : A_WINDOW_T;
                          p3 : c.signed_int;
                          p4 : c.signed_int;
                          p5 : c.signed_int;
                          p6 : c.signed_int;
                          p7 : c.signed_int;
                          p8 : c.signed_int;
                          p9 : c.signed_int;
                          p10: c.signed_int;
                          p11: bool)
                               return c.signed_int;             -- curspriv.h:282

    function PDC_CURSOR_OFF return c.signed_int;                -- curspriv.h:283

    function PDC_CURSOR_ON return c.signed_int;                 -- curspriv.h:284

    function PDC_FIX_CURSOR(p1: c.signed_int) return c.signed_int;-- curspriv.h:285

    function PDC_GATTR return c.signed_int;                     -- curspriv.h:286

    function PDC_GET_BIOS_KEY return c.signed_int;              -- curspriv.h:287

    function PDC_GET_COLUMNS return c.signed_int;               -- curspriv.h:288

    function PDC_GET_CTRL_BREAK return bool;                    -- curspriv.h:289

    function PDC_GET_CUR_COL return c.signed_int;               -- curspriv.h:290

    function PDC_GET_CUR_ROW return c.signed_int;               -- curspriv.h:291

    function PDC_GET_CURSOR_POS(p1: c.a_signed_int_t;
                                p2: c.a_signed_int_t)
                                    return c.signed_int;        -- curspriv.h:292

    function PDC_GET_CURSOR_MODE return c.signed_int;           -- curspriv.h:293

    function PDC_GET_FONT return c.signed_int;                  -- curspriv.h:294

    function PDC_GET_ROWS return c.signed_int;                  -- curspriv.h:295

    function PDC_GOTOXY(p1: c.signed_int;
                        p2: c.signed_int)
                            return c.signed_int;                -- curspriv.h:296

    function PDC_INIT_ATRTAB return c.signed_int;               -- curspriv.h:297

    function PDC_MAKENEW(p1: c.signed_int;
                         p2: c.signed_int;
                         p3: c.signed_int;
                         p4: c.signed_int)
                             return A_WINDOW_T;                 -- curspriv.h:298

    function PDC_NEWLINE(p1: A_WINDOW_T;
                         p2: c.signed_int)
                             return c.signed_int;               -- curspriv.h:299

    function PDC_PRINT(p1: c.signed_int;
                       p2: c.signed_int;
                       p3: c.signed_int)
                           return c.signed_int;                 -- curspriv.h:300

    function PDC_PUTC(p1: chtype;
                      p2: chtype)
                          return c.signed_int;                  -- curspriv.h:301

    function PDC_PUTCHAR(p1: chtype) return c.signed_int;       -- curspriv.h:302

    function PDC_PUTCTTY(p1: chtype;
                         p2: chtype)
                             return c.signed_int;               -- curspriv.h:303

    function PDC_RAWGETCH return c.signed_int;                  -- curspriv.h:304

    function PDC_SANITY_CHECK(p1: c.signed_int) return c.signed_int;-- curspriv.h:305

    function PDC_SCR_CLOSE return c.signed_int;                 -- curspriv.h:306

    function PDC_SCR_OPEN(p1: A_SCREEN_T;
                          p2: bool)
                              return c.signed_int;              -- curspriv.h:307

    function PDC_SCROLL(p1: c.signed_int;
                        p2: c.signed_int;
                        p3: c.signed_int;
                        p4: c.signed_int;
                        p5: c.signed_int;
                        p6: chtype)
                            return c.signed_int;                -- curspriv.h:308

    function PDC_SET_80X25 return c.signed_int;                 -- curspriv.h:309

    function PDC_SET_CTRL_BREAK(p1: bool) return c.signed_int;  -- curspriv.h:310

    function PDC_SET_CURSOR_MODE(p1: c.signed_int;
                                 p2: c.signed_int)
                                     return c.signed_int;       -- curspriv.h:311

    function PDC_SET_FONT(p1: c.signed_int) return c.signed_int;-- curspriv.h:312

    function PDC_SET_ROWS(p1: c.signed_int) return c.signed_int;-- curspriv.h:313

    function PDC_SPLIT_PLANE(p1: A_WINDOW_T;
                             p2: c.charp;
                             p3: c.charp;
                             p4: c.signed_int;
                             p5: c.signed_int;
                             p6: c.signed_int;
                             p7: c.signed_int)
                                 return c.signed_int;           -- curspriv.h:314

    function PDC_SYSGETCH return c.signed_int;                  -- curspriv.h:315

    function PDC_TRANSFORM_LINE(p1: c.signed_int) return bool;  -- curspriv.h:316

    procedure PDC_USLEEP(p1: c.signed_int);                     -- curspriv.h:317

    function PDC_VALIDCHAR(p1: c.signed_int) return c.signed_int;-- curspriv.h:318

    function PDC_QUERY_ADAPTER_TYPE return c.signed_int;        -- curspriv.h:326

    function PDC_GET_SCRN_MODE return c.signed_int;             -- curspriv.h:327

    function PDC_SET_SCRN_MODE(p1: c.signed_int) return c.signed_int;-- curspriv.h:328

    function PDC_SCRN_MODES_EQUAL(p1: c.signed_int;
                                  p2: c.signed_int)
                                      return bool;              -- curspriv.h:329


private

    pragma Import(C, inportb, "inportb");                      -- pc.h:31

    pragma Import(C, inportw, "inportw");                      -- pc.h:32

    pragma Import(C, inportl, "inportl");                      -- pc.h:33

    pragma Import(C, inportsb, "inportsb");                    -- pc.h:34

    pragma Import(C, inportsw, "inportsw");                    -- pc.h:35

    pragma Import(C, inportsl, "inportsl");                    -- pc.h:36

    pragma Import(C, outportb, "outportb");                    -- pc.h:37

    pragma Import(C, outportw, "outportw");                    -- pc.h:38

    pragma Import(C, outportl, "outportl");                    -- pc.h:39

    pragma Import(C, outportsb, "outportsb");                  -- pc.h:40

    pragma Import(C, outportsw, "outportsw");                  -- pc.h:41

    pragma Import(C, outportsl, "outportsl");                  -- pc.h:42

    pragma Import(C, kbhit, "kbhit");                          -- pc.h:44

    pragma Import(C, getkey, "getkey");                        -- pc.h:45

    pragma Import(C, getxkey, "getxkey");                      -- pc.h:46

    pragma Import(C, sound, "sound");                          -- pc.h:48

    pragma Import(C, ScreenMode, "ScreenMode");                -- pc.h:56

    pragma Import(C, ScreenRows, "ScreenRows");                -- pc.h:57

    pragma Import(C, ScreenCols, "ScreenCols");                -- pc.h:58

    pragma Import(C, ScreenPutChar, "ScreenPutChar");          -- pc.h:59

    pragma Import(C, ScreenSetCursor, "ScreenSetCursor");      -- pc.h:60

    pragma Import(C, ScreenGetCursor, "ScreenGetCursor");      -- pc.h:61

    pragma Import(C, ScreenClear, "ScreenClear");              -- pc.h:62

    pragma Import(C, ScreenUpdate, "ScreenUpdate");            -- pc.h:63

    pragma Import(C, ScreenUpdateLine, "ScreenUpdateLine");    -- pc.h:64

    pragma Import(C, ScreenRetrieve, "ScreenRetrieve");        -- pc.h:65

    pragma Import(C, bdos, "bdos");                            -- dos.h:75

    pragma Import(C, bdosptr, "bdosptr");                      -- dos.h:76

    pragma Import(C, int86, "int86");                          -- dos.h:77

    pragma Import(C, int86x, "int86x");                        -- dos.h:78

    pragma Import(C, intdos, "intdos");                        -- dos.h:79

    pragma Import(C, intdosx, "intdosx");                      -- dos.h:80

    pragma Import(C, enable, "enable");                        -- dos.h:82

    pragma Import(C, disable, "disable");                      -- dos.h:83

    pragma Import(C, getftime, "getftime");                    -- dos.h:85

    pragma Import(C, setftime, "setftime");                    -- dos.h:86

    pragma Import(C, getcbrk, "getcbrk");                      -- dos.h:88

    pragma Import(C, setcbrk, "setcbrk");                      -- dos.h:89

    pragma Import(C, getdate, "getdate");                      -- dos.h:91

    pragma Import(C, gettime, "gettime");                      -- dos.h:92

    pragma Import(C, setdate, "setdate");                      -- dos.h:93

    pragma Import(C, settime, "settime");                      -- dos.h:94

    pragma Import(C, getdfree, "getdfree");                    -- dos.h:96

    pragma Import(C, c_delay, "delay");                        -- dos.h:98

    pragma Import(C, get_default_drive, "_get_default_drive"); -- dos.h:99

    pragma Import(C, fixpath, "_fixpath");                     -- dos.h:100

    pragma Import(C, addchnstr, "addchnstr");                  -- curses.h:1060

    pragma Import(C, baudrate, "baudrate");                    -- curses.h:1061

    pragma Import(C, beep, "beep");                            -- curses.h:1062

    pragma Import(C, border, "border");                        -- curses.h:1063

    pragma Import(C, breakchar, "breakchar");                  -- curses.h:1064

    pragma Import(C, can_change_color, "can_change_color");    -- curses.h:1065

    pragma Import(C, clearok, "clearok");                      -- curses.h:1066

    pragma Import(C, color_content, "color_content");          -- curses.h:1067

    pragma Import(C, copywin, "copywin");                      -- curses.h:1068

    pragma Import(C, curs_set, "curs_set");                    -- curses.h:1069

    pragma Import(C, cursoff, "cursoff");                      -- curses.h:1070

    pragma Import(C, curson, "curson");                        -- curses.h:1071

    pragma Import(C, def_prog_mode, "def_prog_mode");          -- curses.h:1072

    pragma Import(C, def_shell_mode, "def_shell_mode");        -- curses.h:1073

    pragma Import(C, delay_output, "delay_output");            -- curses.h:1074

    pragma Import(C, delwin, "delwin");                        -- curses.h:1075

    pragma Import(C, derwin, "derwin");                        -- curses.h:1076

    pragma Import(C, doupdate, "doupdate");                    -- curses.h:1077

    pragma Import(C, dupwin, "dupwin");                        -- curses.h:1078

    pragma Import(C, endwin, "endwin");                         -- curses.h:1079

    pragma Import(C, erasechar, "erasechar");                  -- curses.h:1080

    pragma Import(C, fixterm, "fixterm");                      -- curses.h:1081

    pragma Import(C, flash, "flash");                          -- curses.h:1082

    pragma Import(C, flushinp, "flushinp");                    -- curses.h:1083

    pragma Import(C, gettmode, "gettmode");                    -- curses.h:1084

    pragma Import(C, has_colors, "has_colors");                -- curses.h:1085

    pragma Import(C, hline, "hline");                          -- curses.h:1086

    pragma Import(C, inchnstr, "inchnstr");                    -- curses.h:1087

    pragma Import(C, init_color, "init_color");                -- curses.h:1088

    pragma Import(C, init_pair, "init_pair");                  -- curses.h:1089

    pragma Import(C, initscr, "initscr");                       -- curses.h:1090

    pragma Import(C, intrflush, "intrflush");                  -- curses.h:1091

    pragma Import(C, is_linetouched, "is_linetouched");        -- curses.h:1092

    pragma Import(C, is_wintouched, "is_wintouched");          -- curses.h:1093

    pragma Import(C, keyname, "keyname");                      -- curses.h:1094

    pragma Import(C, killchar, "killchar");                    -- curses.h:1095

    pragma Import(C, longname, "longname");                    -- curses.h:1096

    pragma Import(C, meta, "meta");                            -- curses.h:1097

    pragma Import(C, mvaddrawch, "mvaddrawch");                -- curses.h:1098

    pragma Import(C, mvaddrawstr, "mvaddrawstr");              -- curses.h:1099

    pragma Import(C, mvcur, "mvcur");                          -- curses.h:1100

    pragma Import(C, mvderwin, "mvderwin");                    -- curses.h:1101

    pragma Import(C, mvinsrawch, "mvinsrawch");                -- curses.h:1102

    pragma Import(C, mvprintw, "mvprintw");                    -- curses.h:1103

    pragma Import(C, mvscanw, "mvscanw");                      -- curses.h:1104

    pragma Import(C, mvwin, "mvwin");                          -- curses.h:1105

    pragma Import(C, mvwinsrawch, "mvwinsrawch");              -- curses.h:1106

    pragma Import(C, mvwprintw, "mvwprintw");                  -- curses.h:1107

    pragma Import(C, mvwscanw, "mvwscanw");                    -- curses.h:1108

    pragma Import(C, newpad, "newpad");                        -- curses.h:1109

    pragma Import(C, newterm, "newterm");                      -- curses.h:1110

    pragma Import(C, newwin, "newwin");                        -- curses.h:1111

    pragma Import(C, noraw, "noraw");                          -- curses.h:1112

    pragma Import(C, overlay, "overlay");                      -- curses.h:1113

    pragma Import(C, overwrite, "overwrite");                  -- curses.h:1114

    pragma Import(C, pair_content, "pair_content");            -- curses.h:1115

    pragma Import(C, pnoutrefresh, "pnoutrefresh");            -- curses.h:1116

    pragma Import(C, prefresh, "prefresh");                    -- curses.h:1117

    pragma Import(C, printw, "printw");                        -- curses.h:1118

    pragma Import(C, raw, "raw");                              -- curses.h:1119

    pragma Import(C, refresh, "refresh");                       -- curses.h:1120

    pragma Import(C, reset_prog_mode, "reset_prog_mode");      -- curses.h:1121

    pragma Import(C, reset_shell_mode, "reset_shell_mode");    -- curses.h:1122

    pragma Import(C, resetterm, "resetterm");                  -- curses.h:1123

    pragma Import(C, resetty, "resetty");                      -- curses.h:1124

    pragma Import(C, saveoldterm, "saveoldterm");              -- curses.h:1125

    pragma Import(C, saveterm, "saveterm");                    -- curses.h:1126

    pragma Import(C, savetty, "savetty");                      -- curses.h:1127

    pragma Import(C, scanw, "scanw");                          -- curses.h:1128

    pragma Import(C, scroll, "scroll");                        -- curses.h:1129

    pragma Import(C, set_term, "set_term");                    -- curses.h:1130

    pragma Import(C, start_color, "start_color");              -- curses.h:1131

    pragma Import(C, subpad, "subpad");                        -- curses.h:1132

    pragma Import(C, subwin, "subwin");                        -- curses.h:1133

    pragma Import(C, tabsize, "tabsize");                      -- curses.h:1134

    pragma Import(C, termattrs, "termattrs");                  -- curses.h:1135

    pragma Import(C, termname, "termname");                    -- curses.h:1136

    pragma Import(C, touchline, "touchline");                  -- curses.h:1137

    pragma Import(C, touchwin, "touchwin");                    -- curses.h:1138

    pragma Import(C, typeahead, "typeahead");                  -- curses.h:1139

    pragma Import(C, unctrl, "unctrl");                        -- curses.h:1140

    pragma Import(C, vline, "vline");                          -- curses.h:1141

    pragma Import(C, waddchnstr, "waddchnstr");                -- curses.h:1142

    pragma Import(C, waddnstr, "waddnstr");                    -- curses.h:1143

    pragma Import(C, waddrawstr, "waddrawstr");                -- curses.h:1144

    pragma Import(C, waddstr, "waddstr");                      -- curses.h:1145

    pragma Import(C, wattroff, "wattroff");                    -- curses.h:1146

    pragma Import(C, wattron, "wattron");                      -- curses.h:1147

    pragma Import(C, wattrset, "wattrset");                    -- curses.h:1148

    pragma Import(C, wbkgd, "wbkgd");                          -- curses.h:1149

    pragma Import(C, wbkgdset, "wbkgdset");                    -- curses.h:1150

    pragma Import(C, wborder, "wborder");                      -- curses.h:1151

    pragma Import(C, wclear, "wclear");                        -- curses.h:1152

    pragma Import(C, wclrtobot, "wclrtobot");                  -- curses.h:1153

    pragma Import(C, wclrtoeol, "wclrtoeol");                  -- curses.h:1154

    pragma Import(C, wdelch, "wdelch");                        -- curses.h:1155

    pragma Import(C, wdeleteln, "wdeleteln");                  -- curses.h:1156

    pragma Import(C, werase, "werase");                        -- curses.h:1157

    pragma Import(C, wgetch, "wgetch");                        -- curses.h:1158

    pragma Import(C, wgetnstr, "wgetnstr");                    -- curses.h:1159

    pragma Import(C, wgetstr, "wgetstr");                      -- curses.h:1160

    pragma Import(C, whline, "whline");                        -- curses.h:1161

    pragma Import(C, winchnstr, "winchnstr");                  -- curses.h:1162

    pragma Import(C, winnstr, "winnstr");                      -- curses.h:1163

    pragma Import(C, winsch, "winsch");                        -- curses.h:1164

    pragma Import(C, winsdelln, "winsdelln");                  -- curses.h:1165

    pragma Import(C, winsertln, "winsertln");                  -- curses.h:1166

    pragma Import(C, winsnstr, "winsnstr");                    -- curses.h:1167

    pragma Import(C, wmove, "wmove");                           -- curses.h:1168

    pragma Import(C, wnoutrefresh, "wnoutrefresh");            -- curses.h:1169

    pragma Import(C, wordchar, "wordchar");                    -- curses.h:1170

    pragma Import(C, wprintw, "wprintw");                      -- curses.h:1171

    pragma Import(C, wredrawln, "wredrawln");                  -- curses.h:1172

    pragma Import(C, wrefresh, "wrefresh");                    -- curses.h:1173

    pragma Import(C, wscanw, "wscanw");                        -- curses.h:1174

    pragma Import(C, wscrl, "wscrl");                          -- curses.h:1175

    pragma Import(C, wsetscrreg, "wsetscrreg");                -- curses.h:1176

    pragma Import(C, wtabsize, "wtabsize");                    -- curses.h:1177

    pragma Import(C, wtouchln, "wtouchln");                    -- curses.h:1178

    pragma Import(C, ungetch, "ungetch");                      -- curses.h:1179

    pragma Import(C, wvline, "wvline");                        -- curses.h:1180

    pragma Import(C, raw_output, "raw_output");                -- curses.h:1183

    pragma Import(C, resize_screen, "resize_screen");          -- curses.h:1184

    pragma Import(C, resize_window, "resize_window");          -- curses.h:1185

    pragma Import(C, win_print, "win_print");                  -- curses.h:1186

    pragma Import(C, PDC_CHADD, "PDC_chadd");                  -- curses.h:1192

    pragma Import(C, PDC_CHINS, "PDC_chins");                  -- curses.h:1193

    pragma Import(C, getdosmembyte, "getdosmembyte");          -- curspriv.h:135

    pragma Import(C, getdosmemword, "getdosmemword");          -- curspriv.h:136

    pragma Import(C, setdosmembyte, "setdosmembyte");          -- curspriv.h:137

    pragma Import(C, setdosmemword, "setdosmemword");          -- curspriv.h:138

    pragma Import(C, PDC_BACKCHAR, "PDC_backchar");            -- curspriv.h:274

    pragma Import(C, PDC_BREAKOUT, "PDC_breakout");            -- curspriv.h:275

    pragma Import(C, PDC_CHECK_BIOS_KEY, "PDC_check_bios_key");-- curspriv.h:277

    pragma Import(C, PDC_CHG_ATTR, "PDC_chg_attr");            -- curspriv.h:278

    pragma Import(C, PDC_CLR_SCRN, "PDC_clr_scrn");            -- curspriv.h:280

    pragma Import(C, PDC_CLR_UPDATE, "PDC_clr_update");        -- curspriv.h:281

    pragma Import(C, PDC_COPY_WIN, "PDC_copy_win");            -- curspriv.h:282

    pragma Import(C, PDC_CURSOR_OFF, "PDC_cursor_off");        -- curspriv.h:283

    pragma Import(C, PDC_CURSOR_ON, "PDC_cursor_on");          -- curspriv.h:284

    pragma Import(C, PDC_FIX_CURSOR, "PDC_fix_cursor");        -- curspriv.h:285

    pragma Import(C, PDC_GATTR, "PDC_gattr");                  -- curspriv.h:286

    pragma Import(C, PDC_GET_BIOS_KEY, "PDC_get_bios_key");    -- curspriv.h:287

    pragma Import(C, PDC_GET_COLUMNS, "PDC_get_columns");      -- curspriv.h:288

    pragma Import(C, PDC_GET_CTRL_BREAK, "PDC_get_ctrl_break");-- curspriv.h:289

    pragma Import(C, PDC_GET_CUR_COL, "PDC_get_cur_col");      -- curspriv.h:290

    pragma Import(C, PDC_GET_CUR_ROW, "PDC_get_cur_row");      -- curspriv.h:291

    pragma Import(C, PDC_GET_CURSOR_POS, "PDC_get_cursor_pos");-- curspriv.h:292

    pragma Import(C, PDC_GET_CURSOR_MODE, "PDC_get_cursor_mode");-- curspriv.h:293

    pragma Import(C, PDC_GET_FONT, "PDC_get_font");            -- curspriv.h:294

    pragma Import(C, PDC_GET_ROWS, "PDC_get_rows");            -- curspriv.h:295

    pragma Import(C, PDC_GOTOXY, "PDC_gotoxy");                -- curspriv.h:296

    pragma Import(C, PDC_INIT_ATRTAB, "PDC_init_atrtab");      -- curspriv.h:297

    pragma Import(C, PDC_MAKENEW, "PDC_makenew");              -- curspriv.h:298

    pragma Import(C, PDC_NEWLINE, "PDC_newline");              -- curspriv.h:299

    pragma Import(C, PDC_PRINT, "PDC_print");                  -- curspriv.h:300

    pragma Import(C, PDC_PUTC, "PDC_putc");                    -- curspriv.h:301

    pragma Import(C, PDC_PUTCHAR, "PDC_putchar");              -- curspriv.h:302

    pragma Import(C, PDC_PUTCTTY, "PDC_putctty");              -- curspriv.h:303

    pragma Import(C, PDC_RAWGETCH, "PDC_rawgetch");            -- curspriv.h:304

    pragma Import(C, PDC_SANITY_CHECK, "PDC_sanity_check");    -- curspriv.h:305

    pragma Import(C, PDC_SCR_CLOSE, "PDC_scr_close");          -- curspriv.h:306

    pragma Import(C, PDC_SCR_OPEN, "PDC_scr_open");            -- curspriv.h:307

    pragma Import(C, PDC_SCROLL, "PDC_scroll");                -- curspriv.h:308

    pragma Import(C, PDC_SET_80X25, "PDC_set_80x25");          -- curspriv.h:309

    pragma Import(C, PDC_SET_CTRL_BREAK, "PDC_set_ctrl_break");-- curspriv.h:310

    pragma Import(C, PDC_SET_CURSOR_MODE, "PDC_set_cursor_mode");-- curspriv.h:311

    pragma Import(C, PDC_SET_FONT, "PDC_set_font");            -- curspriv.h:312

    pragma Import(C, PDC_SET_ROWS, "PDC_set_rows");            -- curspriv.h:313

    pragma Import(C, PDC_SPLIT_PLANE, "PDC_split_plane");      -- curspriv.h:314

    pragma Import(C, PDC_SYSGETCH, "PDC_sysgetch");            -- curspriv.h:315

    pragma Import(C, PDC_TRANSFORM_LINE, "PDC_transform_line");-- curspriv.h:316

    pragma Import(C, PDC_USLEEP, "PDC_usleep");                -- curspriv.h:317

    pragma Import(C, PDC_VALIDCHAR, "PDC_validchar");          -- curspriv.h:318

    pragma Import(C, PDC_QUERY_ADAPTER_TYPE, "PDC_query_adapter_type");-- curspriv.h:326

    pragma Import(C, PDC_GET_SCRN_MODE, "PDC_get_scrn_mode");  -- curspriv.h:327

    pragma Import(C, PDC_SET_SCRN_MODE, "PDC_set_scrn_mode");  -- curspriv.h:328

    pragma Import(C, PDC_SCRN_MODES_EQUAL, "PDC_scrn_modes_equal");-- curspriv.h:329

end Curses;
