
------------------------------------------------------------
--        Name: Alden Dima
--      E-mail: dimaaa@seas.gwu.edu
--      School: The George Washington University
--              School of Engineering and Applied Science
--              Washington, D.C.
--       Class: CSci 298 - Independent Study
--     Project: Ada Curses Binding and Textual User Interface
--        File: twiddle.adb 
--        Date: 12/25/95
-- Description: Generic package specification of Ada-callable
--              bit-wise logical operations for integer-sized
--              types. 
------------------------------------------------------------

generic
   type ada_int_type is (<>);
   type c_int_type   is (<>);

package twiddle is
--
-- Bitwise logical operators
--
   function "and" (left, right : ada_int_type) return ada_int_type;
   function "or"  (left, right : ada_int_type) return ada_int_type;
   function "xor" (left, right : ada_int_type) return ada_int_type;
   function "not" (num : ada_int_type) return ada_int_type;

--
-- Left/right shifting functions
--
   function lshift (num, bits : ada_int_type) return ada_int_type;
   function rshift (num, bits : ada_int_type) return ada_int_type;

end twiddle;
