--  The Ada 95 Booch Components (Version 0.4q)
--  (C) Copyright 1987-1994 Grady Booch.
--  (C) Copyright 1994-1996 Grady Booch and David Weller.
--
-- The Ada 95 Booch Components is a collection of free software components.
-- You can redistribute it and/or modify it under terms of the Ada
-- Community License.
--

with BC.Support.Bounded;
generic
   Max_Size : Positive;
package BC.Queues.Bounded is

	-- See spec documentation for Queues unless overriding comment apply.

   package Bnd_Queue_Nodes is new BC.Support.Bounded(Item, Max_Size);

   type Bnd_Queue is new Queue with private;

   procedure Clear    (Obj : in out Bnd_Queue);
   procedure Append   (Obj : in out Bnd_Queue; Elem : Item);
   procedure Pop      (Obj : in out Bnd_Queue);
   procedure Remove   (Obj : in out Bnd_Queue; From : Natural);
   function Available (Obj : in Bnd_Queue) return Natural;
	-- Indicated number of empty "Item slots" left in Queue

   function Length    (Obj : in Bnd_Queue) return Natural;
   function Is_Empty  (Obj : in Bnd_Queue) return Boolean;
   function Front     (Obj : in Bnd_Queue) return Item;
   function Location  (Obj : in Bnd_Queue; Elem : Item) return Natural;

   function "="(Left, Right : in Bnd_Queue) return boolean;
   function Cardinality(Obj : in Bnd_Queue) return Integer;
   procedure Purge(Obj : in out Bnd_Queue);
   procedure Add(Obj : in out Bnd_Queue; Elem : in out Item);
   function Item_At (Obj : Bnd_Queue; Index : Natural) return Item;

private
   function Item_At (Obj : Bnd_Queue; Index : Natural) return Item_Ptr;

   type Bnd_Queue is new Queue with record
      Rep : Bnd_Queue_Nodes.Bnd_Node;
   end record;

end BC.Queues.Bounded;
