--  The Ada 95 Booch Components (Version 0.4q)
--  (C) Copyright 1987-1994 Grady Booch.
--  (C) Copyright 1994-1996 Grady Booch and David Weller.
--
-- The Ada 95 Booch Components is a collection of free software components.
-- You can redistribute it and/or modify it under terms of the Ada
-- Community License.
--

package body Bc.Queues is

   function Item_At (Obj : Queue; Index : Natural) return Item is
      Never_Assign_A_Value : Item;
   begin
      pragma Assert ( False, "Failure to override Item_At operation");
      raise Abstraction_Violation;
      return Never_Assign_A_Value;
   end Item_At;

   function Item_At (Obj : Queue; Index : Natural) return Item_Ptr is
   begin
      pragma Assert ( False, "Failure to override Item_At operation");
      raise Abstraction_Violation;
      return null;
   end Item_At;

   procedure Purge (Obj : in out Queue) is
   begin
      pragma Assert ( False, "Failure to override Item_At operation");
      raise Abstraction_Violation;
      null;
   end Purge;

   procedure Add (Obj : in out Queue; Elem : in out Item) is
   begin
      pragma Assert ( False, "Failure to override Item_At operation");
      raise Abstraction_Violation;
      null;
   end Add;

   function Cardinality (Obj : Queue) return Integer is
   begin
      pragma Assert ( False, "Failure to override Item_At operation");
      raise Abstraction_Violation;
      return 0;
   end Cardinality;

   function Current_Item (Obj : Iterator) return Item_Ptr is
   begin
      return Item_At (Obj.Q.all, Obj.Index);
   end Current_Item;

   function "=" (Left, Right : access Queue'Class) return Boolean is
   begin
      if Left.all = Right.all then
     return True;
      elsif Cardinality (Left.all) /= Cardinality (Right.all) then
     return False;
      else
     declare
        Left_Iter : Iterator (Left);
        Right_Iter : Iterator (Right);
     begin
        while not Is_Done (Left_Iter) and not Is_Done (Right_Iter) loop
           if Current_Item (Left_Iter).all /=
         Current_Item (Right_Iter).all then
          return False;
           end if;
           Next (Left_Iter);
           Next (Right_Iter);
        end loop;
        return True;
     end;
      end if;
   end "=";

   procedure Copy (From : access Queue'Class; To : access Queue'Class) is
      Iter : Iterator (From);
   begin
      Clear (To.all);
      Reset (Iter);
      while not Is_Done (Iter) loop
     Append (To.all, Current_Item (Iter).all);
     Next (Iter);
      end loop;
   end Copy;

   procedure Reset (Obj : in out Iterator) is
   begin
      if Cardinality (Obj.Q.all) > 0 then
     Obj.Index := 1;
      else
     Obj.Index := 0;
      end if;
   end Reset;

   procedure Next (Obj : in out Iterator) is
   begin
      Obj.Index := Obj.Index + 1;
   end Next;

   function Is_Done (Obj : Iterator) return Boolean is
   begin
     return (Obj.Index < 1) or else (Obj.Index > Cardinality (Obj.Q.all));
   end Is_Done;

   procedure Apply (Obj : in out Passive_Iterator; Success : out Boolean) is
      Iter : Iterator(Obj.Q);
   begin
      while not Is_Done(Iter) loop
     Apply_Method(Current_Item(Iter).all, Success);
     if Success then
        Next(Iter);
     else
        Obj.Success := False;
        return;
     end if;
      end loop;
   end Apply;

end Bc.Queues;
